﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows.Media;

using Buddy.Common;

namespace WingIt
{
    public static class Logger
    {
        public static void Write(string message)
        {
            Write(Colors.Green, message);
        }

        public static void Write(string message, params object[] args)
        {
            Write(Colors.Green, message, args);
        }

        public static void Write(Color clr, string message, params object[] args)
        {
            Logging.Write(clr, "[WingIt] " + message, args);
        }

        public static void MaintenanceError(string message, params object[] args)
        {
            string          formattedMessage    = string.Format(message, args);
            StackTrace      trace               = new StackTrace(1);

            Logging.WriteDiagnostic(Colors.DarkRed, "[WingIt, MAINTENANCE ERROR] {0}\nLocation:\n{1}",
                                    formattedMessage, trace.ToString());
        }
    }
}
