﻿using System;
using System.Linq;

using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Swtor;

using snipe = WingIt.Routines.Advanced.Sniper.Sniper;
using marks = WingIt.Routines.Advanced.Sniper.Marksmanship;
using lethality = WingIt.Routines.Advanced.Sniper.Lethality;
using eng = WingIt.Routines.Advanced.Sniper.Engineering;

using WingIt.Dynamics;
namespace WingIt.Routines.Advanced.Gunslinger
{
    //this simply points to the Sniper which will apply the Sniper.Mirror logic to auto cast Gunslinger abilities
    //so remember don't worry about this file just tune the sniper files
    public class Gunslinger
    {
        public static Composite GunslingerPull()
        {
            return snipe.SniperCombat();
        }

        public static Composite GunslingerCombat()
        {
            return snipe.SniperCombat();
        }

        #region Sharpshooter
        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerSharpshooter)]
        public static Composite SharpshooterCombat()
        {
            return marks.MarksmanshipCombat();
        }

        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerSharpshooter)]
        public static Composite SharpshooterPull()
        {
            return marks.MarksmanshipPull();
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerSharpshooter)]
        public static Composite SharpshooterPostCombat()
        {
            return marks.MarksmanshipPostCombat();
        }
        #endregion


        #region Saboteur
        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerSaboteur)]
        public static Composite SaboteurCombat()
        {
            return eng.EngineeringCombat();
        }

        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerSaboteur)]
        public static Composite SaboteurPull()
        {
            return eng.EngineeringPull();
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerSaboteur)]
        public static Composite SaboteurPostCombat()
        {
            return eng.EngineeringPostCombat();
        }
        #endregion


        #region Dirty Fighting
        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerDirtyFighting)]
        public static Composite DirtyFightingCombat()
        {
            return lethality.LethalityCombat();
        }

        [Behavior(BehaviorType.Pull)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerDirtyFighting)]
        public static Composite DirtyFightingPull()
        {
            return lethality.LethalityPull();
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Gunslinger, SkillTreeId.GunslingerDirtyFighting)]
        public static Composite DirtyFightingPostCombat()
        {
            return lethality.LethalityPostCombat();
        }
        #endregion

    }
}
