﻿using System.Linq;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.Swtor;
using WingIt.Dynamics;

namespace WingIt.Routines
{
    public static class Scoundrel
    {
        [Behavior(BehaviorType.Combat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Scoundrel, SkillTreeId.None)]
        public static Composite ScoundrelCombat()
        {
            return new PrioritySelector(
                Movement.StopInRange(Global.RangeDistance),

				// Cover so we can use our stuff
                // Spell.Cast("Take Cover", ret => !Global.IsInCover),
                Spell.Cast("Crouch", ret => !Global.IsInCover),

				// AoE Grenade, High Damage
                Spell.Cast("Thermal Grenade", ret => Global.IsInCover),
				
				// Medium DPS Grenade
                Spell.Cast("Sabotage Charge", ret => Global.IsInCover),
				
				// add usage
                Spell.Cast("Aimed Shot", ret => Global.IsInCover),
				
				// Medium DPS Shot
                Spell.Cast("Charged Burst", ret => Global.IsInCover),
				
				// Medium DPS shot
                Spell.Cast("Quick Slot", ret => Global.IsInCover),
				
				// Low DPS shot
                Spell.Cast("Flurry of Bolts", ret => Global.IsInCover),
				
               Movement.MoveTo(ret => BuddyTor.Me.CurrentTarget.Position, Global.RangeDistance)
            );
        }

        [Behavior(BehaviorType.OutOfCombat)]
        [Class(CharacterClass.Smuggler, AdvancedClass.Scoundrel, SkillTreeId.None)]
        public static Composite ScoundrelPostCombat()
        {
            // PostCombat handling prevents the 'stuck handler dance' if combat ends in crouch/cover
            return (CommonSubBT.CreateBTPS_BreakCrouchOrCover());
        }
    }
}

