﻿using System;
using System.Runtime.Serialization;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.Swtor;
using System.Linq;
using WingIt.Dynamics;

using Action = Buddy.BehaviorTree.Action;

namespace WingIt.Routines.Basic
{
    public class Knight
    {
        [Class(CharacterClass.Knight)]
        [Behavior(BehaviorType.Combat)]
        public static Composite KnightCombat()
        {
            //Neo93 29.04.2012
            return new PrioritySelector(
                Spell.WaitForCast(),
                Movement.StopInRange(Global.MeleeDistance),

                //***General***
                Spell.Cast("Force Leap", castWhen => Helpers.IsInRange(Global.RangeDistance, 1f) && !BuddyTor.Me.CurrentTarget.IsCoverAffected),
                Spell.Cast("Resolute", castWhen => BuddyTor.Me.IsStunned),//Insignia/2m CD

                //**Defensive**
                Spell.BuffSelf("Saber Ward", castWhen => BuddyTor.Me.InCombat && BuddyTor.Me.HealthPercent <= 50),//3m CD

                //**Offensive**
                Spell.Cast("Blade Storm"),//-4 Focus
                Spell.Cast("Force Sweep", castWhen => Helpers.MobsAround(Global.MeleeDistance) >= 3 && Helpers.Targets.Count() >= 3),//-3 Focus/15s CD
                Spell.Cast("Master Strike"),//0 Focus/27s CD
                Spell.WaitForCast(),
                Spell.Cast("Riposte"),//-3 Focus
                Spell.Cast("Slash"),//-3 Focus
                Spell.Cast("Strike"),//+2 Focus

                //Movement
                Movement.MoveTo(whereTo => BuddyTor.Me.CurrentTarget.Position, Global.MeleeDistance)
                );
        }

        [Class(CharacterClass.Knight)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite KnightOutOfCombat()
        {
            return new PrioritySelector(
                Spell.BuffSelf("Shii-Cho Form")
                );
        }

        [Class(CharacterClass.Knight)]
        [Behavior(BehaviorType.Pull)]
        public static Composite KnightPull()
        {
            return KnightCombat();
        }
    }
}