﻿using System;
using Buddy.BehaviorTree;
using Buddy.CommonBot;
using Buddy.Swtor;
using System.Linq;
using WingIt.Dynamics;

namespace WingIt.Routines.Basic
{
    public class Warrior
    {
        [Class(CharacterClass.Warrior)]
        [Behavior(BehaviorType.Pull)]
        public static Composite WarriorPull()
        {
            return WarriorCombat();
        }

        [Class(CharacterClass.Warrior)]
        [Behavior(BehaviorType.Combat)]
        public static Composite WarriorCombat()
        {
            //Neo93 29.04.2012
            return new PrioritySelector(
                Spell.WaitForCast(),
                Movement.StopInRange(Global.MeleeDistance),

                //***General***
                Spell.Cast("Force Charge", ret => Helpers.IsInRange(Global.RangeDistance, 1f) && !BuddyTor.Me.CurrentTarget.IsCoverAffected), //+3 Rage/15s CD/30m Range - Pull
                Spell.Cast("Unleash", castWhen => BuddyTor.Me.IsStunned),//Insignia/2m CD

                //**Defensive**
                Spell.BuffSelf("Saber Ward", castWhen => BuddyTor.Me.InCombat && BuddyTor.Me.HealthPercent <= 50),//3m CD

                //**Offensive**
                Spell.Cast("Force Scream"),//-4Rage/2s CD
                Spell.Cast("Smash", castWhen => Helpers.MobsAround(Global.MeleeAoEDistance) >= 3 && Helpers.Targets.Count() >= 3),//-3 Rage/15s CD
                Spell.Cast("Ravage"),//0 Rage/27s CD
                Spell.Cast("Retaliation"),//-3 Rage
                Spell.Cast("Vicious Slash"),//-3 Rage
                Spell.Cast("Assault"),//+2 Rage

                //Movement
                Movement.MoveTo(ret => BuddyTor.Me.CurrentTarget.Position, Global.MeleeDistance)
                );
        }

        [Class(CharacterClass.Warrior)]
        [Behavior(BehaviorType.OutOfCombat)]
        public static Composite WarriorOutOfCombat()
        {
            return new PrioritySelector(
                Spell.BuffSelf("Shii-Cho Form")
                );
        }
    }
}