﻿using System.Linq;
using Buddy.Swtor;

namespace WingIt.Routines
{
    //This is for every class
    class Global
    {
        public static bool IsInCover { get { return (BuddyTor.Me.HasBuff("Crouch") || BuddyTor.Me.HasBuff("Cover")); } }
        public static bool IsInGroup { get { return Helpers.Group.Count() > 2; } }
        public static bool IsElite { get { return BuddyTor.Me.CurrentTarget != null && BuddyTor.Me.CurrentTarget.Toughness >= CombatToughness.Strong; } }
        public static bool RequiresCrowdControl { get { return BuddyTor.Me.CurrentTarget != null && (BuddyTor.Me.CurrentTarget.IsCasting || !(BuddyTor.Me.CurrentTarget.Toughness == CombatToughness.Standard || BuddyTor.Me.CurrentTarget.Toughness == CombatToughness.Weak)); } }

        #region Combat Interaction Ranges
        /// <summary>
        /// Maximum range for interaction with targets for melee.
        /// This value should also be used for cleave-style AoE attacks.
        /// </summary>
        public const float MeleeDistance = 0.35f;
        /// <summary>
        /// Some melee AoE spells are effective at greater than melee distance, but less than range distance.
        /// Examples include:<list type="bullet">
        /// <item><description><para> * Jedi Knight's "Awe" / Sith Juggernaut's "Intimidating Roar"</para></description></item>
        /// <item><description><para> * Jedi Consular's "Force Wave" / Sith Inquisitor's "Overload"</para></description></item>
        /// </list>
        /// This is NOT a 'cleave range', use <c>MeleeDistance</c> for that.
        /// </summary>
        public const float MeleeAoEDistance = 0.8f;
        /// <summary>
        /// Maximum range for interaction with targets at a distance.
        /// </summary>
        public const float RangeDistance = 2.8f;
        #endregion  // Combat Interaction Ranges

        public const int EnergyMinimum = 65;
        public const int CellMinimum = 8;
        
        public const int FullHealth = 100;
        public const int HighHealth = 80;
        public const int MidHealth = 50;
        public const int LowHealth = 30;
        public const int OhShit = 15;
        public const int HealthShield = 90;
        public const int HealthCritical = 40;
        public const int CompHealing = 90;
    }
}
